#ifndef EFL_GENERATED_EDJE_EDIT_HH
#define EFL_GENERATED_EDJE_EDIT_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "edje_edit.eo.h"
}

#include "edje_object.eo.hh"

namespace edje { 

struct edit
      : edje::object
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit edit(Eo* eo)
      : edje::object(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit edit(std::nullptr_t)
      : edje::object(nullptr)
   {}

   edit(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : edit(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   edit(edit const& other)
      : edje::object(eo_ref(other._eo_ptr()))
   {}

   ~edit() {}

   static Eo_Class const* _eo_class()
   {
      return(EDJE_EDIT_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(EDJE_EDIT_CLASS, _p._eo_raw, eo_constructor());
   }

};
} 

namespace efl { namespace eo { namespace detail {

template<>
struct operations< edje::edit >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< edje::edit >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<edje::edit>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< edje::edit >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<edje::edit, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< edje::edit >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<edje::edit, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< edje::edit>
{
   template <typename U>
   struct type
   {
      operator edje::edit() const
      {
         return edje::edit(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<edje::edit>)
{
   return (EDJE_EDIT_CLASS);
}

} } }
#endif // EFL_GENERATED_EDJE_EDIT_HH

